Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 458164

Summary: net-libs/webkit-gtk-1.10.2-r300: linking Programs/WebKitPluginProcess fails due to missing -lrt
Product: Gentoo Linux Reporter: SpanKY <vapier>
Component: [OLD] GNOMEAssignee: Gentoo Linux Gnome Desktop Team <gnome>
Status: RESOLVED FIXED    
Severity: normal CC: brad, gentoo, toolchain
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: Linux   
See Also: http://sourceware.org/bugzilla/show_bug.cgi?id=15126
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on:    
Bug Blocks: 372079    
Attachments: webkit-gtk build log
webkit-gtk-1.10.2-underlinking.patch
webkit-gtk-1.10.2-gcc-4.8.patch

Description SpanKY gentoo-dev 2013-02-18 19:32:25 UTC
Created attachment 339286 [details]
webkit-gtk build log

/usr/lib/gcc/x86_64-pc-linux-gnu/4.7.2/../../../../x86_64-pc-linux-gnu/bin/ld: Source/WebKit2/Platform/unix/Programs_WebKitPluginProcess-SharedMemoryUnix.o: undefined reference to symbol 'shm_unlink@@GLIBC_2.2.5'
/usr/lib/gcc/x86_64-pc-linux-gnu/4.7.2/../../../../x86_64-pc-linux-gnu/bin/ld: note: 'shm_unlink@@GLIBC_2.2.5' is defined in DSO /lib64/librt.so.1 so try adding it to the linker command line
/lib64/librt.so.1: could not read symbols: Invalid operation
collect2: error: ld returned 1 exit status
make[1]: *** [Programs/WebKitPluginProcess] Error 1



Portage 2.2.0_alpha163 (default/linux/amd64/13.0/developer, gcc-4.7.2, glibc-2.17, 3.7.6 x86_64)
=================================================================
System uname: Linux-3.7.6-x86_64-AMD_Phenom-tm-_II_X4_980_Processor-with-gentoo-2.2
KiB Mem:     8168760 total,    275932 free
KiB Swap:          0 total,         0 free
Timestamp of tree: Sun, 17 Feb 2013 18:30:01 +0000
ld GNU ld (Linux/GNU Binutils) 2.23.51.0.9.20130118
distcc 3.1 x86_64-pc-linux-gnu [disabled]
ccache version 3.1.9 [enabled]
app-shells/bash:          4.2_p42
dev-java/java-config:     2.1.12-r1
dev-lang/python:          2.7.3-r3, 3.2.3-r2
dev-util/ccache:          3.1.9
dev-util/cmake:           2.8.10.2-r1
dev-util/pkgconfig:       0.28
sys-apps/baselayout:      2.2
sys-apps/openrc:          9999
sys-apps/sandbox:         2.6
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.9.6-r3, 1.10.3, 1.11.6, 1.12.6, 1.13.1
sys-devel/binutils:       2.17-r1, 2.17.50.0.2::<unknown repository>, 2.17.50.0.3::<unknown repository>, 2.17.50.0.4::<unknown repository>, 2.17.50.0.5::<unknown repository>, 2.17.50.0.6::<unknown repository>, 2.17.50.0.7::<unknown repository>, 2.17.50.0.8::<unknown repository>, 2.17.50.0.9::<unknown repository>, 2.17.50.0.10::<unknown repository>, 2.17.50.0.11::<unknown repository>, 2.17.50.0.12::<unknown repository>, 2.17.50.0.13::<unknown repository>, 2.17.50.0.14::<unknown repository>, 2.17.50.0.15::<unknown repository>, 2.17.50.0.16, 2.17.50.0.17, 2.17.50.0.18, 2.18-r2, 2.18.50.0.1, 2.18.50.0.2, 2.18.50.0.3, 2.18.50.0.4, 2.18.50.0.5, 2.18.50.0.6, 2.18.50.0.7, 2.18.50.0.8, 2.18.50.0.9, 2.19, 2.19.1-r1, 2.19.50.0.1, 2.19.51.0.1, 2.19.51.0.2, 2.19.51.0.3, 2.19.51.0.4, 2.19.51.0.5, 2.19.51.0.6, 2.19.51.0.10, 2.19.51.0.11, 2.19.51.0.12, 2.19.51.0.14, 2.20, 2.20.1-r1, 2.20.51.0.1, 2.20.51.0.2, 2.20.51.0.3, 2.20.51.0.4, 2.20.51.0.5, 2.20.51.0.6, 2.20.51.0.7, 2.20.51.0.8, 2.20.51.0.9, 2.20.51.0.10, 2.20.51.0.11, 2.21, 2.21.1-r1, 2.21.51.0.1, 2.21.51.0.2, 2.21.51.0.3, 2.21.51.0.4, 2.21.51.0.5, 2.21.51.0.6, 2.21.51.0.7, 2.21.51.0.8, 2.21.51.0.9, 2.21.52.0.1, 2.21.52.0.2, 2.21.53.0.1, 2.21.53.0.2, 2.22-r1, 2.22.52.0.1, 2.22.52.0.2, 2.22.52.0.3, 2.22.52.0.4, 2.22.90, 2.23, 2.23.1, 2.23.51.0.1, 2.23.51.0.2, 2.23.51.0.3, 2.23.51.0.5, 2.23.51.0.6, 2.23.51.0.7, 2.23.51.0.8, 2.23.51.0.9, 9999
sys-devel/gcc:            3.3.5.20050130-r2, 3.3.6-r1, 3.4.3.20050110-r2, 3.4.4-r1, 3.4.5-r1, 3.4.6-r2, 4.0.0, 4.0.1, 4.0.2-r3, 4.0.3, 4.0.4, 4.1.0-r1, 4.1.1-r3, 4.1.2, 4.2.0::toolchain, 4.2.1::toolchain, 4.2.2::toolchain, 4.2.3::toolchain, 4.2.4-r1, 4.3.0::toolchain, 4.3.1-r1::toolchain, 4.3.2-r4::toolchain, 4.3.3-r2, 4.3.4, 4.3.5, 4.3.6-r1, 4.4.0-r1::toolchain, 4.4.1::toolchain, 4.4.2, 4.4.3-r3, 4.4.4-r2, 4.4.5, 4.4.6-r1, 4.4.7, 4.5.0::toolchain, 4.5.1-r1, 4.5.2, 4.5.3-r2, 4.5.4, 4.6.0, 4.6.1-r1, 4.6.2, 4.6.3, 4.7.0, 4.7.1, 4.7.2
sys-devel/gcc-config:     1.8
sys-devel/libtool:        2.4.2
sys-devel/make:           3.82-r4
sys-kernel/linux-headers: 3.7 (virtual/os-headers)
sys-libs/glibc:           2.17
Repositories: gentoo local enlightenment
Installed sets: @system
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* foo"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -march=amdfam10 -pipe -g -Wimplicit-function-declaration"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt /usr/share/polkit-1/actions"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CPPFLAGS="-DCPPFLAGS_TEST"
CXXFLAGS="-O2 -march=amdfam10 -pipe -g"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--nospinner --keep-going --quiet-build=n -1 -v"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs buildsyspkg ccache collision-protect compressdebug config-protect-if-modified digest distlocks ebuild-locks fixlafiles merge-sync news noinfo parallel-fetch preserve-libs protect-owned sandbox sfperms sign splitdebug strict test-fail-continue unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="en_US.UTF8"
LDFLAGS="-Wl,-O1 -Wl,--hash-style=gnu"
MAKEOPTS="-j5"
PKGDIR="/usr/portage/packages"
PORTAGE_COMPRESS="xz"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_EXTRA_OPTS="--chmod=a+r,ug+w,Da+x --exclude='ChangeLog*' --exclude=metadata.xml"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/local/portage /usr/local/src/gentoo/overlays/vapier/enlightenment"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="3dnow 3dnowext X a52 aac aalib acl acpi adns agg aio alsa amd64 apache2 apng asf aspell atsc audiofile berkdb bitmap-fonts bzip2 cairo caps cdaudio cdda cddb cdparanoia cdr cli console cracklib crypt css ctype curl cvs cxx dba dbus divx4linux dri dts dvb dvd dvdr dvdread encode exif expat extensions fbcon ffmpeg flac flash fluidsynth fontconfig fortran ftp g3dvl gcj gd gif glib glitz glut gmp go gphoto2 gstreamer gtk gtk2 htmlhandbook iconv imap imlib introspection ipv6 jbig joystick jpeg jpeg2k kde kpathsea lcms libcaca libkms libnotify libv4l lzma lzo lzw mad maildir matroska midi mime mjpeg mmx mmxext mng modules mp3 mp4 mpeg mplayer mtp mudflap multilib multislot musepack ncurses network nls nptl nptlonly nsplugin nvidia offensive ogg oggvorbis openal opengl openmp pcre pdf perl pic png policykit postgres pulse pulseaudio pvr python qt4 quicktime readline redland rss samba sdl session smp sndfile speex spell sql sqlite sse sse2 ssl subtitles subversion svg syslog tcl tcltk tcpd tga theora threads tiff tk truetype udev udisks unicode upnp upower usb v4l vaapi vcd vdpau video vlc vnc vorbis vpx wavpack webkit wma wmf wxwidgets x264 xanim xattr xcb xcomposite xine xinerama xinetd xml xml2 xorg xpm xrandr xv xvid xvmc zip zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump" CAMERAS="canon" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="mouse keyboard joystick void" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en en_US en_GB de" PHP_TARGETS="php5-3" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_2" QEMU_SOFTMMU_TARGETS="alpha arm i386 mips mips64 mips64el mipsel ppc ppc64 s390x sh4 sh4eb sparc sparc64 x86_64" QEMU_USER_TARGETS="alpha arm armeb i386 mips mipsel ppc ppc64 ppc64abi32 s390x sh4 sh4eb sparc sparc32plus sparc64" RUBY_TARGETS="ruby18 ruby19" USERLAND="GNU" VIDEO_CARDS="nvidia nv nouveau ati r128 radeon radeonhd vga sisusb" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CTARGET, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS_FLAGS, USE_PYTHON
Comment 1 SpanKY gentoo-dev 2013-02-18 20:25:27 UTC
hmm, might be a bug in new binutils
Comment 2 Alexandre Rostovtsev (RETIRED) gentoo-dev 2013-02-18 21:59:54 UTC
> /lib64/librt.so.1: could not read symbols: Invalid operation

Sounds like a bug either in glibc or in binutils.
Comment 3 SpanKY gentoo-dev 2013-02-28 08:17:57 UTC
i think you're focusing on the wrong part.  i'm pretty sure the webkit package is missing an -lrt in its link.  it's using shm_* symbols from librt but not linking against it.
Comment 4 Ted Tanberry 2013-04-28 15:05:44 UTC
This bug has been fixed upstream (https://bugs.webkit.org/show_bug.cgi?id=103194). I've backported the fix for 1.10.2-r300 as the patch doesn't apply cleanly.

As a sidenote, I didn't want to open a separate bug for that, but gcc-4.8 throws out a lot of warnings, that are never fatal in themselves but still annoying. This too has been dealt with by upstream (https://bugs.webkit.org/show_bug.cgi?id=113147).
Comment 5 Ted Tanberry 2013-04-28 15:06:10 UTC
diff -u /usr/portage/net-libs/webkit-gtk/webkit-gtk-1.10.2-r300.ebuild /usr/local/portage/net-libs/webkit-gtk/webkit-gtk-1.10.2-r300.ebuild
--- /usr/portage/net-libs/webkit-gtk/webkit-gtk-1.10.2-r300.ebuild	2013-01-29 14:01:24.000000000 +0100
+++ /usr/local/portage/net-libs/webkit-gtk/webkit-gtk-1.10.2-r300.ebuild	2013-04-28 15:03:26.796388090 +0200
@@ -159,6 +159,13 @@
 	# https://bugs.gentoo.org/show_bug.cgi?id=449220#c17
 	epatch "${FILESDIR}/${PN}-1.10.2-wifexited.patch"
 
+	# patch for gcc 4.8, to disable
+	# COMPILE_ASSERT warnings, https://bugs.webkit.org/show_bug.cgi?id=113147
+	epatch "${FILESDIR}/${P}-gcc-4.8.patch"
+
+	# patch for underlinking issue, bug #458164
+	epatch "${FILESDIR}/${P}-underlinking.patch"
+
 	# Respect CC, otherwise fails on prefix #395875
 	tc-export CC
Comment 6 Ted Tanberry 2013-04-28 15:06:49 UTC
Created attachment 346796 [details, diff]
webkit-gtk-1.10.2-underlinking.patch
Comment 7 Ted Tanberry 2013-04-28 15:07:13 UTC
Created attachment 346798 [details, diff]
webkit-gtk-1.10.2-gcc-4.8.patch
Comment 8 Alexandre Rostovtsev (RETIRED) gentoo-dev 2013-05-28 05:24:10 UTC
Fixed without a revision bump. Ted, thanks for finding and backporting the patches!

+  28 May 2013; Alexandre Rostovtsev <tetromino@gentoo.org>
+  webkit-gtk-1.10.2-r300.ebuild, +files/webkit-gtk-1.10.2-gcc-4.8.patch,
+  +files/webkit-gtk-1.10.2-librt.patch:
+  Fix build failure due to underlinking and silence excessive warnings with
+  gcc-4.8 (bug #458164, thanks to Ted Tanberry and Mike Frysinger).